-- reference transformer
-- ossmann@fh-aachen.de
-- 26.th june 2011
-- 28.th june 2013

myName="Trafo1Example1V01.lua"

print ("start of ",myName)
		  
MagneticProblem=0
newdocument(MagneticProblem)
	 
Hz=1 kHz=1e3 MHz=1e6 
mm=1e-3 
Amp=1 mAmp=1e-3 uAmp=1e-6
mH=1e-3 uH=1e-6
Deg=1

	  	  
pi=3.1415926535
mu0=4.0E-7*pi

-- add the notion of points
	  
function X_point(r,z)
  return  { r=r,z=z }
  end
	
function X_midpoint(p1,p2)
  return  {r=(p1.r+p2.r)/2.0,z=(p1.z+p2.z)/2.0 }
  end
		
function X_addnode(p)
  mi_addnode( p.r,  p.z )  
  end
	  
function X_addsegment(p1,p2)
  mi_addsegment( p1.r, p1.z , p2.r,p2.z)  
  end
	  
function  X_addarc( p1 , p2 , phi , dphi )
  mi_addarc(  p1.r , p1.z , p2.r , p2.z , phi , dphi )
  end
		
function X_addblocklabel( p )
  mi_addblocklabel( p.r, p.z )
  end

function  X_selectlabel( p )   
  mi_selectlabel( p.r, p.z )   
  end
	   
function X_setsimplematerial(blklbl,Material,MeshSize)	
  X_addblocklabel( blklbl )
  X_selectlabel( blklbl )   
  mi_setblockprop(Material,  0,  MeshSize,  0,  0,  0,  0)      
  mi_clearselected()
  end
	
-- setup materials	
MUE_Fe=50000

	  
Frequency=10*kHz

TheTurns1=10 

TheTurns2=10 



Ra=8*mm
Rb=12*mm
Rc=14*mm
Rd=18*mm

MeshFactor=1

DomainMeshSize=MeshFactor*2.0*mm	
MeshSize=MeshFactor*1.0*mm
WindingMeshSize=MeshFactor*0.5*mm




mi_addmaterial("Fe",  MUE_Fe,  MUE_Fe,  0,  0,  0,  0,  0,  0,  0,  0)  -- high mu ferrite
mi_addmaterial("air",  1,  1,  0,  0,  0,  0,  0,  0,  0,  0)   
mi_addmaterial("Wdg",  1,  1,  0,  0,  0,  0,  0,  0,  0,  0) -- used for windings

mi_probdef( Frequency , "meters", "axi", "1E-8")      
-- domain setup
DomainR=50*mm ;
Dp1=X_point( 0,  DomainR)
Dp2=X_point( 0, -DomainR)
X_addnode(Dp1)
X_addnode(Dp2)
X_addsegment(Dp1,Dp2)	  
X_addarc( Dp2 , Dp1 ,180*Deg, 3*Deg )
	 
mi_addboundprop("outer",  0,  0,  0,  0,  0,  0,  0,  0,  0)    
mi_selectarcsegment( DomainR , 0 )  
mi_setarcsegmentprop( 5*Deg , "outer",  0, 0 )      
mi_clearselected()     

	  	 
-- Assigning material properties
AIR_blklbl=X_point( 0.9*DomainR , 0 )
X_addblocklabel( AIR_blklbl )
X_selectlabel( AIR_blklbl )   
  
mi_setblockprop("air",  0,  DomainMeshSize,  0,  0,  0,  0)      
mi_clearselected()      

	 --CC1---------------------------------------CC2
	 --cc1------a1----b1----c1----d1-----cc2     |	  
	 -- |        |     |     |     |       |      |	
	 -- |        |     |     |     |       |      |	
	 -- |        |     |     |     |       |      |	
	 --cc4------a2----b2----c2----d2-----cc3     |	
	 --CC4---------------------------------------CC3
RR=35*mm
HH=45*mm
CC1=X_point(0 , HH/2.0)
CC2=X_point(RR, HH/2.0)
CC3=X_point(RR,-HH/2.0)
CC4=X_point(0 ,-HH/2.0) 
X_addnode(CC1) X_addnode(CC2) X_addnode(CC3) X_addnode(CC4)
X_addsegment(CC1,CC2) X_addsegment(CC2,CC3) X_addsegment(CC3,CC4)	
	 
R5=25*mm
h=30*mm
hh=h
cc1=X_point(0 , h/2.0)
cc2=X_point(R5, h/2.0)
cc3=X_point(R5,-h/2.0)
cc4=X_point(0 ,-h/2.0) 
X_addnode(cc1) X_addnode(cc2) X_addnode(cc3) X_addnode(cc4)
X_addsegment(cc1,cc2) X_addsegment(cc2,cc3) X_addsegment(cc3,cc4)	
	 
a1=X_point(Ra, h/2.0) a2=X_point(Ra,-h/2.0)  X_addnode(a1) X_addnode(a2) X_addsegment(a1,a2)
b1=X_point(Rb, h/2.0) b2=X_point(Rb,-h/2.0)  X_addnode(b1) X_addnode(b2) X_addsegment(b1,b2)
c1=X_point(Rc, h/2.0) c2=X_point(Rc,-h/2.0)  X_addnode(c1) X_addnode(c2) X_addsegment(c1,c2)
d1=X_point(Rd, h/2.0) d2=X_point(Rd,-h/2.0)  X_addnode(d1) X_addnode(d2) X_addsegment(d1,d2)

BlkLbl=X_midpoint(cc1,a2) X_setsimplematerial(BlkLbl,"air",MeshSize)
BlkLbl=X_midpoint(b1,c2)  X_setsimplematerial(BlkLbl,"air",MeshSize)
BlkLbl=X_midpoint(d1,cc3) X_setsimplematerial(BlkLbl,"air",MeshSize)
BlkLbl=X_midpoint(cc2,CC3) X_setsimplematerial(BlkLbl,"Fe",MeshSize)
	 
	
W1_blklbl=X_midpoint( a1 , b2 )
X_addblocklabel( W1_blklbl )
X_selectlabel( W1_blklbl )  
mi_setblockprop("Wdg",  0,  WindingMeshSize, "Coil1",  0,  0,  TheTurns1)      
mi_clearselected()      
	   
W2_blklbl=X_midpoint( c1 , d2 )
X_addblocklabel( W2_blklbl )
X_selectlabel( W2_blklbl )  
mi_setblockprop("Wdg",  0,  WindingMeshSize, "Coil2",  0,  0,  TheTurns2)      
mi_clearselected()  
	  
--mi_zoom(-0.1*DomainR,-1.1*DomainR,1.1*DomainR,1.1*DomainR)
mi_zoom(-0.1*RR,-1.1*HH/2,1.1*RR,1.1*HH/2)

mi_saveas("transf2.fem")    
mi_createmesh()   

--Defining Excitations

Current1= 1.7*Amp
Current2=0.0*Amp

SeriesConnected=1
mi_addcircprop("Coil1",  Current1, SeriesConnected )      
mi_addcircprop("Coil2",  Current2, SeriesConnected ) 
	
mi_analyze( 1)      
mi_loadsolution()      
mo_smooth("on")    
--    mo_hidecontourplot()
	  
legendOn=1
colour=0 	  
--mo_showdensityplot( legendOn,  colour,  0.0003,  0, "bmag")      
	  
Spacing=1.5137*mm
--mo_setgrid(Spacing,"cart")
--Hplot=2	Scale=1	mo_showvectorplot(Hplot,Scale)   
	  
-- clearconsole()
showconsole()

print("Ra=",Ra/mm," mm")
print("Rb=",Rb/mm," mm")
print("Rc=",Rc/mm," mm")
print("Rd=",Rd/mm," mm")
print("h= ", h/mm," mm")
print("Np= ", TheTurns1)
print("Ns= ", TheTurns2)
print(format("Frequency=%5.2f kHz",Frequency/kHz))   	 
	
LLcurrent,LLvolts,LLflux=mo_getcircuitproperties("Coil1")
psi11=LLvolts/(2*pi*I*Frequency) ;
L11femm1=psi11/Current1
LLcurrent,LLvolts,LLflux=mo_getcircuitproperties("Coil2")
psi12=LLvolts/(2*pi*I*Frequency) ;	
L12femm1=psi12/Current1 ;
	
 
  
messagebox("Start second setup")
Current1=0.0*Amp ;
Current2=2.0*Amp ;
	
CurrentIndex =1 
mi_modifycircprop("Coil1",  CurrentIndex , Current1  )   
mi_modifycircprop("Coil2",  CurrentIndex , Current2  )   
mi_analyze( 1)      
mi_loadsolution()      
mo_smooth("on")    
--mo_hidecontourplot()

mo_zoom(-0.1*RR,-1.1*HH/2,1.1*RR,1.1*HH/2)
	  
legendOn=1
colour=0 	  
mo_showdensityplot( legendOn,  colour,  0.001,  0, "bmag")      
mo_setgrid(Spacing,"cart")
--Hplot=2	Scale=1	mo_showvectorplot(Hplot,Scale)   
	  
showconsole()
  
LLcurrent,LLvolts,LLflux=mo_getcircuitproperties("Coil1")
psi21=LLvolts/(2*pi*I*Frequency) ;
L21femm2=psi21/Current2 ;
LLcurrent,LLvolts,LLflux=mo_getcircuitproperties("Coil2")
psi22=LLvolts/(2*pi*I*Frequency) ;	
L22femm2=psi22/Current2 ;

function Lij(Ri,Ro,ri,ro,Np,Ns,h)
  local L11=mu0*Np^2/h*pi*(3*Ri^2+2*Ro*Ri+Ro^2)/6.0
  local L12=mu0*Np*Ns/h*pi*(Ro^2+Ri*Ro+Ri^2)/3.0
  local L22=mu0*Ns^2/h*pi*(3*ri^2+2*ro*ri+ro^2)/6.0
  return L11,L12,L22
  end
L11ana,L12ana,L22ana=Lij(Ra,Rb,Rc,Rd,TheTurns1,TheTurns2,h)
L21ana=L12ana ;

print("Femm results:")
print(format("L11 = %15.8f uH",L11femm1 /uH)	)
print(format("L12 = %15.8f uH",L12femm1 /uH)	)
print(format("L21 = %15.8f uH",L21femm2 /uH)	)
print(format("L22 = %15.8f uH",L22femm2 /uH)	)

print("analytical results:")
print(format("L11 = %15.8f uH   relErr = %15.8f",L11ana /uH, (L11femm1-L11ana)/L11ana)	)
print(format("L12 = %15.8f uH   relErr = %15.8f",L12ana /uH, (L12femm1-L12ana)/L12ana)	)
print(format("L21 = %15.8f uH   relErr = %15.8f",L21ana /uH, (L21femm2-L21ana)/L21ana)	)
print(format("L22 = %15.8f uH   relErr = %15.8f",L22ana /uH, (L22femm2-L22ana)/L22ana)	)




k=sqrt(   (L12ana*L21ana)/(L11ana*L22ana)  )
print(format("k = %15.8f" ,k)	)

filename="FemmLog.txt"
print("open:",filename) ;
LogFile=openfile(filename,"w")
write(LogFile,"written by ",myName," \n") ;

write(LogFile,"Ra=",Ra/mm," mm\n")
write(LogFile,"Rb=",Rb/mm," mm\n")
write(LogFile,"Rc=",Rc/mm," mm\n")
write(LogFile,"Rd=",Rd/mm," mm\n")
write(LogFile,"h= ", h/mm," mm\n")
write(LogFile,"Np= ", TheTurns1,"\n")
write(LogFile,"Ns= ", TheTurns2,"\n")
write(LogFile,format("Frequency=%5.2f kHz\n\n",Frequency/kHz))   	 
	


write(LogFile,"Femm results:\n")
write(LogFile,format("L11 = %15.8f uH\n",L11femm1 /uH)	)
write(LogFile,format("L12 = %15.8f uH\n",L12femm1 /uH)	)
write(LogFile,format("L21 = %15.8f uH\n",L21femm2 /uH)	)
write(LogFile,format("L22 = %15.8f uH\n",L22femm2 /uH)	)

write(LogFile,"analytical results:\n")
write(LogFile,format("L11 = %15.8f uH   relErr = %15.8f\n",L11ana /uH, (L11femm1-L11ana)/L11ana)	)
write(LogFile,format("L12 = %15.8f uH   relErr = %15.8f\n",L12ana /uH, (L12femm1-L12ana)/L12ana)	)
write(LogFile,format("L21 = %15.8f uH   relErr = %15.8f\n",L21ana /uH, (L21femm2-L21ana)/L21ana)	)
write(LogFile,format("L22 = %15.8f uH   relErr = %15.8f\n",L22ana /uH, (L22femm2-L22ana)/L22ana)	)


closefile(LogFile)


print ("stop of ",myName)

 
   